<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

class ZS_MySQLLink extends ZS_Base implements ZS_DBLink
{
	private $mysql_ressource;
	private $count = 0;
	private $time = 0;
	
	public final function setConnection($mysql)
	{
		$mysql_ressource = $mysql;
	}
	
	public final function Connect($host, $user, $pass, $db)
	{
		if ($ressource = mysql_connect($host, $user, $pass))
		{
			$this->mysql_ressource = $ressource;
			if (mysql_select_db($db, $this->mysql_ressource))
			{
				return $this->mysql_ressource;
			}
			else
			{
				die("501 : <strong>Error, cannot select database.</strong>");
			}
		}
		else
		{
			die("500 : <strong>Error, cannot connect to MySQL server.</strong>");
		}
	}
	
	public final function Close()
	{
		mysql_close($this->mysql_ressource);
	}
	
	public final function query($sql)
	{
		$this->count++;
		$current = $this->getMicroTime();
		if ($result = mysql_query($sql, $this->mysql_ressource))
		{
			$this->time += $this->getMicroTime() - $current;
			return $result;
		}
		$this->time += $this->getMicroTime() - $current;
		return false;
	}
	
	public final function fetch($result)
	{
		$row = mysql_fetch_assoc($result);
		return $row;
	}
	
	public final function result($result)
	{
		$row = mysql_result($result, 0);
		return $row;
	}
	
	public final function getCount()
	{
		return $this->count;
	}
	
	public final function getTime()
	{
		return $this->time;
	}
	
	private final function getMicroTime()
	{
		list($usec, $sec) = explode(" ",microtime()); 
		return ((float)$usec + (float)$sec); 
	}
	
	public final function lastId()
	{
		return mysql_insert_id($this->mysql_ressource);
	}
}

?>